function    [f,f_min,grad,hes]=myfun_con_inexact(n,num_con,x,option,Index_Out,Index_Inner);
global example;
global Inner_num_con;
global sum_num;
global N;
m=length(Index_Out);
m
m1=length(num_con);
if option==1
    f=cell(m1,1);
    f_min=zeros(m1,1);
    switch example
        case 10
            global tt;
            global y1;
            b=x(1)*exp(-x(2)*tt).*cos(x(3)*tt+...
                x(4))+x(5)*exp(-x(6)*tt)-y1+...
                x(3)/x(2)*exp(-tt*x(1)).*sin(tt*x(2))-10;
            g=0.5*x'*x-10*N*y1;
            f1=zeros(3,N);
            f1(1,:)=b-5*y1;
            f1(2,:)=-b+y1;

            f1(3,:)=g;
            for i=1:N
                f{i}=f1(:,i);
                f_min(i)=min(f{i});
            end
        case 11
            f{1}=x'*x-40;
            f{2}=-sum((x(2:end)-10).^2)-40*(x(1)+4)^2+500;
 
            s=0.25+0.75*[0:Inner_num_con-1]/(Inner_num_con-1);
            s=s';
            sum_x=sum(x(1:end-1));
            cos_x=cos(sum_x);

            f{3}=x(end)-(s.*sum_x).^2+ s.*cos_x-sqrt(s);

            f{4}=10-x(1)-sum((x(2:end)+14).^2);
            f{5}=100-(x(1)-2)^2-sum((x(2:end)+20).^2);
            f_min(1)=f{1};
            f_min(2)=f{2};
            f_min(3)=min(f{3});
            f_min(4)=f{4};
            f_min(5)=f{5};

    end
    N_f=N_f+1;
elseif option==2
    grad=cell(m,1);

        for i=1:m
            s=Index_Out(i);
             len=length(Index_Inner{s});   % compute active component functions number
            sum_num=sum_num+len;
        end
    switch example

        case 10
        global tt;
         t_need=tt(Index_Out);
         for i=1:m
            grad{i}=[];
            s1=Index_Inner{Index_Out(i)};
            k1=ismember(1, s1);
            k2=ismember(2,s1);
            if k1| k2
                grad_b=zeros(6,1);
                grad_b=[exp(-x(2)*t_need(i)).*cos(x(3)*t_need(i)+x(4))+x(3)/x(2)*exp(-t_need(i)*x(1)).*sin(t_need(i)*x(2)).*(-t_need(i));
                    -t_need(i).*exp(-x(2)*t_need(i)).*cos(x(3)*t_need(i)+x(4))*x(1)+ x(3)*exp(-t_need(i)*x(1)).*(cos(t_need(i)*x(2)).*t_need(i)*x(2)...
                    -sin(t_need(i)*x(2)))/x(2)^2;
                    -t_need(i).*exp(-x(2)*t_need(i)).*sin(x(3)*t_need(i)+x(4))*x(1)+exp(-t_need(i)*x(1)).*sin(t_need(i)*x(2))/x(2);
                    -x(1)*exp(-x(2)*t_need(i)).*sin(x(3)*t_need(i)+x(4));
                    exp(-x(6)*t_need(i));
                    -x(5)*(exp(-x(6)*t_need(i)).*t_need(i))];    % 6 \times num_con
                if k1
                    grad{i}=[grad{i} grad_b];
                end
                if k2
                   grad{i}=[grad{i} -grad_b]; 
                end
           end
            if ismember(3,s1)
                grad_g=2*x;
                grad{i}=[grad{i} grad_g];
            end
  
        end
        case 11
          k=1;
        while 1
            
            if Index_Out(k)-1==0
                grad{k}=2*x;
                k=k+1;
                if k>m
                    break;
                end
            end
            if Index_Out(k)-2==0
                grad{k}=[-80*(x(1)+4);-2*(x(2:end)-10)];
                k=k+1;
                if k>m
                    break;
                end
            end
            if Index_Out(k)-3==0
                s1=Index_Inner{Index_Out(k)};
                l=[0:Inner_num_con-1];
                len=length(s1);
                s=0.25+0.75*l(s1)/(Inner_num_con-1);
                grad{k}=zeros(n, len);
                sum_x=sum(x(1:end-1));
                sin_x=sin(sum_x);

                grad{k}(1:end-1,:)=-2*x(1:end-1)*(s.^2)-sin_x*ones(n-1,1)*s;

                grad{k}(end,:)=ones(1,len);

                
                
%                 a=[1;-2*x(2:end)] ;
%                 if length(s1)==1
%                     
%                     if s1==1
%                         grad{k}=a;
%                     elseif s1==2
%                         grad{k}=-a;
%                     end
%                 else
%                     grad{k}=[a -a];
%                 end
                k=k+1;
                if k>m
                    break;
                end
                

            end
            if Index_Out(k)-4==0
                grad{k}=[-1;-2*(x(2:end)+14)];
                k=k+1;
                if k>m
                    break;
                end
            end
            if Index_Out(k)-5==0
                grad{k}=[-2*(x(1)-2);-2*(x(2:end)+20)];
                break;
            end
        end
        
 
    end
  
    f=[];f_min=[];

elseif option==3
    hes=cell(m,1);
    switch example
        case 10
        global tt;
        t_need=tt(Index_Out);
        for i=1:m
            hes{i}=[];
            s1=Index_Inner{Index_Out};
            k1=ismember(1, s1);
            k2=ismember(2,s1);
            if k1| k2
                hes{i}=[];
                hes_b=zeros(36,1);

                hes_b([1 2 3 4 8 9 10  15 16  22  30 36])= [x(3)/x(2)*exp(-t_need(i)*x(1)).*sin(t_need(i)*x(2)).*t_need(i).^2;
                    -t_need(i).*exp(-x(2)*t_need(i)).*cos(x(3)*t_need(i)+x(4))+...
                    x(3)*exp(-t_need(i)*x(1)).*(-t_need(i)).*(cos(t_need(i)*x(2)).*t_need(i)*x(2)-sin(t_need(i)*x(2)))/x(2)^2;
                    -t_need(i).*exp(-x(2)*t_need(i)).*sin(x(3)*t_need(i)+x(4))+exp(-t_need(i)*x(1)).*sin(t_need(i)*x(2)).*(-t_need(i))/x(2);
                    -exp(-x(2)*t_need(i)).*sin(x(3)*t_need(i)+x(4));
                    t_need(i).^2.*exp(-x(2)*t_need(i)).*cos(x(3)*t_need(i)+x(4))*x(1)+...
                    x(3)*exp(-t_need(i)*x(1)).*((-sin(t_need(i)*x(2)).*(t_need(i).^2*x(2))+cos(t_need(i)*x(2)).*t_need(i)-...
                    cos(t_need(i)*x(2)).*t_need(i))*x(2)-...
                    2*(cos(t_need(i)*x(2)).*t_need(i)*x(2)-sin(t_need(i)*x(2))))/x(2)^3;
                    t_need(i).^2.*exp(-x(2)*t_need(i)).*sin(x(3)*t_need(i)+x(4))*x(1)+...
                    exp(-t_need(i)*x(1)).*(cos(t_need(i)*x(2)).*t_need(i)*x(2)-sin(t_need(i)*x(2)))/x(2)^2;
                    t_need(i).*exp(-x(2)*t_need(i)).*sin(x(3)*t_need(i)+x(4))*x(1);
                    -t_need(i).^2.*exp(-x(2)*t_need(i)).*cos(x(3)*t_need(i)+x(4))*x(1);
                    -t_need(i).*exp(-x(2)*t_need(i)).*cos(x(3)*t_need(i)+x(4))*x(1);
                    -exp(-x(2)*t_need(i)).*cos(x(3)*t_need(i)+x(4))*x(1);
                    -exp(-x(6)*t_need(i)).*t_need(i);
                    exp(-x(6)*t_need(i)).*t_need(i).^2*x(5)];
          
                hes_b([7  13 14 19 20 21 35])=hes_b([2 3 9  4 10 16 30]);
                if k1
                    hes{i}=[hes{i} hes_b];
                end
                if k2
                    hes{i}=[hes{i} -hes_b];
                end

            end
            if ismember(3,s1)
                b=[1:6];
                a=zeros(6^2,1);
                a(1:b+6:end)=1;
                hes_g=2*a;               
                hes{i}=[hes{i} hes_g];
            end

        end
        case 11
       k=1;
        a=zeros(n^2,1);
        while 1
            if Index_Out(k)-1==0
                b=[1:n-1];
                a(1:n+b:end)=2;
                hes{k}=a;
                k=k+1;
                if k>m
                    break;
                end
                a(1)=0;
            end
            if Index_Out(k)-2==0
                a(1)=-80;
                b=[1:n-2];
                a(n+2:n+b:end)=-2;
                hes{k}=a;
                k=k+1;
                if k>m
                    break;
                end
                a(1)=0;
            end
            if Index_Out(k)-3==0
                s1=Index_Inner{Index_Out(k)};
                len=length(s1);
                l=[0:Inner_num_con-1];

                s=0.25+0.75*l(s1)/(Inner_num_con-1);
                sum_x=sum(x(1:end-1));
                cos_x=cos(sum_x);
                hes{k}=zeros(n^2,len);

                b=[1:n-1];
                a(1:n+b:end-1)=-2;
                a(end)=0;
                c=zeros(n^2,1);
                c(1:n+b:end-1)=-cos_x;
                hes{k}=a*(s.^2)+c*s;
   
                k=k+1;
                if k>m
                    break;
                end
            end
            if Index_Out(k)-4==0
                b=[1:n-2];
                a(n+2:n+b:end)=-2;
                hes{k}=a;
                k=k+1;
                if k>m
                    break;
                end
            end
            if Index_Out(k)-5==0
                b=[1:n-2];
                a(1)=-2;
                a(n+2:n+b:end)=-2;
                hes{k}=a;
                break;
            end
        end
 
    end
      f=[];f_min=[];grad=[];

else  disp   ('Error objective !');
end

