function         [f,f_min,grad,hes]=myfun_obj(n,num_obj,x,option);  
global example;
global N;
m=length(num_obj);
if option==1 
    f=cell(m,1);
    f_min=zeros(m,1);
    switch example
        case 1
%             f{1}=x'*x-x(1);
            f{1}=x(1)^2+(x(2)-2)^2;

            f_min(1)=f{1};
        case 2
            f{1}=(x(1)-1)^2+x(2)^2;
            f{2}=(x(1)-0.5)^2+x(2)^2;
            f_min(1)=f{1};
            f_min(2)=f{2};
        case 3
            f{1}=100*(x(2)-x(1)^2)^2+(1-x(1))^2;
            f_min(1)=f{1}; 
        case 4
            %             f{1}=0.2*sum((x-4).^2);
            f{1}=sum((x-4).^2);
            
            e=ones(n,1);
            f{2}=e'*x;
            f_min(1)=f{1};
            f_min(2)=f{2};

        case 5
            f{1}=x(n);
            f_min(1)=f{1};
        case 6
            for i=1:N
                f{i}=[sum((x(1:n-1)-1+i/m).^2)-i/m-x(end) sum((x(1:n-1)+1+i/m).^2)-i/m-x(end)]';
                f_min(i)=min(f{i});
            end
        case 7
            f{1}=x(1);
            f_min(1)=f{1};
        case 8
            C1=0.1;
            C2=0.5;
            f{1}=x(1)^2+C1*sum(x(2:N+1))^2+C2*sum(x(N+2:end))^2;
            f_min(1)=f{1};
        case 9
            f{1}=x(2);
            f_min(1)=f{1};
        case 10
            f{1}=(x(1)-10)^2+5*(x(2)-12)^2+x(3)^4+3*(x(4)-11)^2+10*x(5)^6+7*x(6)^2-...
                4*x(5)*x(6);
            f_min=f{1};
        case 11
            f{1}=sum((2-x).^2);
            f{2}=2*exp(x(end)-sum(x(1:end-1)));
            f_min(1)=f{1};
            f_min(2)=f{2};

%             f{1}=100*(x(2)-x(1)^2)^2+(1-x(1))^2;
%             f_min(1)=f{1};
%         case 2   % Robot obstacle problem
%             f{1}=x(1);
%             f_min(1)=f{1};
%         case 3
%             f{1}=sum(x.^2)-4*x(1)*x(2);
%             f_min=f{1};
%         case 4
%             f{1}=x(end);
%             f_min=f{1};
%         case 5
%             f{1}=x(1)^2+x(2)^2;
%             f_min=f{1};
%         case 6
%             a=0;
%             for j=1:n-1
%                 a=a+100*(x(j)^2-x(j+1))^2+(x(j)-1)^2;;
%             end
%             f{1}=a;
%             f_min=f{1};
    end
elseif option==2
    grad=cell(m,1);
    switch example
        case 1
%             grad{1}=2*x-[1;zeros(n-1,1)];
            grad{1}=2*[x(1);x(2)-2];
        case 2
            grad{1}=2*[x(1)-1;x(2)];
            grad{2}=2*[x(1)-0.5;x(2)];
        case 3
            grad{1}=[-2*(1-x(1))-400*x(1)*(x(2)-x(1)^2); 200*(x(2)-x(1)^2)];  
        case 4
%             grad{1}=0.4*(x-4);
            grad{1}=2*(x-4);

            e=ones(n,1);
            grad{2}=e;

        case 5
            grad{1}=[zeros(n-1,1);1];
        case 6
            for i=1:N
                grad{i}=[[2*(x(1:n-1)-1+i/m);-1] [2*(x(1:n-1)+1+i/m);-1]];
            end
        case 7
            grad{1}=[1;zeros(2*N,1)];
        case 8
            C1=0.1;
            C2=0.5;
            grad{1}=2*[x(1);C1*x(2:N+1);C2*x(N+2:end)];
        case 9
            grad{1}=[0;1];
        case 10
            grad{1}=[2*(x(1)-10);
            10*(x(2)-12);
            4*x(3)^3;
            6*(x(4)-11);
            60*x(5)^5-4*x(6);
            14*x(6)-4*x(5)];
        case 11
            
         grad{1}=-2*(2-x);
        grad{2}=2*exp(x(end)-sum(x(1:end-1)))*[-ones(n-1,1);1];      
 %         case 1
%             grad{1}=[-2*(1-x(1))-400*x(1)*(x(2)-x(1)^2); 200*(x(2)-x(1)^2)];
%         case 2
%             grad{1}=[1;zeros(n-1,1)];
%         case 3
%             grad{1}=2*x-4*[x(2);x(1)];
%         case 4
%             grad{1}=[zeros(n-1,1);1];
%         case 5
%             grad{1}=2*x;
%         case 6
%             g=zeros(n,1);
%             for  i=2:n
%                 a=x(i-1)^2-x(i); b=x(i-1)-1;
%                 g(i-1)=g(i-1)+400*x(i-1)*a+2*b;
%                 g(i)=g(i)-200*a;
%             end
%             grad{1}=g;
    end
    f=[];
    f_min=[];
elseif option==3 
    hes=cell(m,1);
    switch example
        case 1
            hes{1}=2*reshape(speye(n),n^2,1);
        case 2
            hes{1}=2*[1 0 0 1]';
            hes{2}=2*[1 0 0 1]';
        case 3
            hes{1}=[2-400*(x(2)-x(1)^2)+800*x(1)^2  -400*x(1) -400*x(1)  200]';
        case 4
%             hes{1}=0.4*reshape(speye(n),n^2,1);
%             hes{1}=2*reshape(speye(n),n^2,1);

%             hes{2}=zeros(n^2,1);
case 5
    hes{1}=zeros(n^2,1);
case 6
    hes{1}=zeros(n^2,1);
case 7
    hes{1}=zeros(n^2,1);
case 8
    %             hes{1}=zeros(n^2,1);
    %             C1=0.1;
    %             C2=0.5;
    %             b=n+[1:N];
    %             hes{1}(1)=2;
    %             hes{1}(n+2:b:n*N+N+1)=2*C1;
    %             hes{1}(n*(N+1)+N+2:b:n^2)=2*C2;
    %         case 1
    %             hes{1}=[2-400*(x(2)-x(1)^2)+800*x(1)^2  -400*x(1) -400*x(1)  200]';
    %         case 2
    %             hes{1}=zeros(n^2,1);
    %         case 3
    %             hes{1}=(2*[1 0 0 1]-4*[0 1 1 0])';
    %         case 4
    %             hes{1}=zeros(n^2,1);
    %         case 5
    %             hes{1}=2*[1 0 0 1]';
    %         case 6
    %             h=zeros(n);
    %             for i=1:n-1
    %                 a=x(i)^2-x(i+1);
    %                 h(i,i)=2+400*a+800*x(i)^2;
    %                 h(i,i+1)=-400*x(i);
    %                 h(i+1,i)=h(i,i+1);
    %                 h(i+1,i+1)=200;
    %             end
    %             hes{1}=reshape(h,n^2,1);
        case 9
            hes{1}=zeros(4,1);
        case 10

            a=zeros(n^2,1);
            a(1)=2;
            a(1+1+6)=10;
            a(1+(1+6)*2)=12*x(3)^2;
            a(1+(1+6)*3)=6;
            a(1+(1+6)*4)=300*x(5)^4;
            a(1+(1+6)*4+1)=-4;
            a(end-1)=-4;
            a(end)=14;
            hes{1}=a;
        case 11
       a=zeros(n^2,1);
        b=[1:n-1];
        a(1:n+b:end)=2;
        hes=cell(2,1);
        hes{1}=a;
        b=[-ones(n-1,1);1];
        c=exp(x(end)-sum(x(1:end-1)));
        d=reshape(b*b',n^2,1);
        hes{2}=2*c*d;
    end
f=[];f_min=[];grad=[];
% elseif option==4
%     f=cell(m,1);
%     f_min=zeros(m,1);
%     hes=cell(m,1);
%     grad=cell(m,1);
%     switch example
%         case 1
%             f{1}=100*(x(2)-x(1)^2)^2+(1-x(1))^2;
%             f_min(1)=f{1};
%             grad{1}=[-2*(1-x(1))-400*x(1)*(x(2)-x(1)^2); 200*(x(2)-x(1)^2)];
%             hes{1}=[2-400*(x(2)-x(1)^2)+800*x(1)^2  -400*x(1) -400*x(1)  200]';
%         case 2
%             f{1}=x(1);
%             f_min(1)=f{1};
%             grad{1}=[1;zeros(n-1,1)];
%             hes{1}=zeros(n^2,1);
%         case 3
%             f{1}=sum(x.^2)-4*x(1)*x(2);
%             f_min=f{1};
%             grad{1}=2*x-4*[x(2);x(1)];
%             hes{1}=(2*[1 0 0 1]-4*[0 1 1 0])';
%     end
else    disp   ('Error objective !');
end
