function x=B_K_solver(A,p,s,b)
% To solve A*x=b
% Permute PAP'Px=Pb, PAP'=LDL'; LDL'Px=Pb
% L*D*L'*x=b;
% global n;
% B=A;
% b1=b;
n=length(b);
%  [A,p,s]=Bunch_Kaufmann(A)
% [A,p,s]=Bounded_Bunch_Kaufmann(A)
% do interchange of b 
for i=1:n
    if p(i)~=0
        t=b(i);
        b(i)=b(p(i));
        b(p(i))=t;
    end
end

% solve Lz=b
z=zeros(n,1);
if s(1)==1
    z(1)=b(1);
    i=2;
else
    z(1:2)=b(1:2);
    i=3;
end
while 1
    if s(i)==1
        z(i)=b(i)-A(i,1:i-1)*z(1:i-1);
        i=i+1;
    else
        z(i:i+1)=b(i:i+1)-A(i:i+1,1:i-1)*z(1:i-1);
        i=i+2;
    end
    if i>n-1
        break;
    end
end
if s(n-1)==1
    z(n)=b(n)-A(n,1:n-1)*z(1:n-1);
end
% solve D*y=z;
y=zeros(n,1);
i=1;
while 1
    if s(i)==1
        y(i)=z(i)/A(i,i);
        i=i+1;
    elseif s(i)==2
          y(i:i+1)=equation_solver(A(i:i+1,i:i+1),z(i:i+1));
        i=i+2;
    end   
    if i>n-1
        break
    end
end
if s(n-1)==1
   y(n)=z(n)/A(n,n);
end

% solve L'x=y
x=zeros(n,1);
x(n)=y(n);
i=n-1;
while 1
    if s(i)==2
        x(i:i+1)=y(i:i+1)-A(i+2:n,i:i+1)'*x(i+2:n);
        i=i-1;
    elseif s(i)==1 & s(i-1)==1
        x(i)=y(i)-A(i+1:n,i)'*x(i+1:n);
        i=i-1;
    elseif  s(i)==1 & s(i-1)==2
        x(i-1:i)=y(i-1:i)-A(i+1:n,i-1:i)'*x(i+1:n);
        i=i-2;
    end
    if i<2
        break;
    end
end
if s(1)==1
    x(1)=y(1)-A(2:n,1)'*x(2:n);
end

% d=x;
for i=n:-1:1    % why inverse sequence ????  
    if p(i)~=0
        t=x(i);
        x(i)=x(p(i));
        x(p(i))=t;
    end
end
% d1=B\b1; % x=(A)^(-1)*(b)
% d-d1