function     h=Pivot_Gauss(A,b);
A1=A;
% Column-Pivot to solve Ax=b
n=length(b);
Index=zeros(n,1);
for k=1:n-1
   [a,p]=max(abs(A(k:n,k))) ; 
   if a~=abs(A(k,k))
       p=p+k-1;
       t=A(k,:);
       A(k,:)=A(p,:);
       A(p,:)=t;
       Index(k)=p;
   end
   if abs(A(k,k))>1e-7
       A(k+1:n,k)=A(k+1:n,k)/A(k,k);
       A(k+1:n,k+1:n)=A(k+1:n,k+1:n)-A(k+1:n,k)*A(k,k+1:n);
   else
       fprintf('Singular matrix!');   
       break;
   end
    
end
Index
% L=speye(n);
% U=zeros(n);
% U(1,:)=A(1,:);
% U(n,n)=A(n,n);
% L(n,1:n-1)=A(n,1:n-1);
% for i=2:n-1
%     L(i,1:i-1)=A(i,1:i-1);
%     U(i,i:n)=A(i,i:n);
% end
% for i=1:n
%     if Index(i)~=0
%         t=A1(i,:);
%         A1(i,:)=A1(Index(i),:);
%         A1(Index(i),:)=t;
%     end
% end
% A1-L*U
% Index
for i=1:n
    if Index(i)~=0
        t=b(i);
        b(i)=b(Index(i));
        b(Index(i))=t;
    end
end
y=zeros(n,1);
y(1)=b(1);
for i=2:n
    y(i)=b(i)-A(i,1:i-1)*y(1:i-1);
end
h=zeros(n,1);
h(n)=y(n)/A(n,n);
for i=n-1:-1:1
    h(i)=(y(i)-A(i,i+1:n)*h(i+1:n))/A(i,i);
end

return
