function mainfun_ADCH_sequential_minimaxmin
% clc
clear all


% ADCH for CSMMP  08.2.22 revised 
% theta-aggregate para;
% n---the dimension of the problem
% x_initial----initial point of the algorithm
% example---denotes the example
global theta;
global x_initial;
global n;
global num_obj;  %  a vector to save the number of min_function for the objective function
global num_con;  %  a vector to save the number of min_function for the constraint function
global example;  
global N_f;      % use for denoting the computation number 
global N_g;
global N_h;
global para;
global con_initial;  % denote the initial constraint value

global rou;      % parameter necessary for the deformation
global p;
global beta_1;
global beta_2;
global hes;
global hes_con;
theta=1e-6;
para.Newton=1;
para.bound=1;
global N;
% global num_con;
global num_obj;
global Inner_num_con;
global sum_num;
global inexact; % inexact=1, use TADH, inexact=0, use ADH

inexact=1;

sum_num=0;
%%  for example 10  %%%%%
% 
% global tt;   
% global y1;
% n=6;
% num_con=3;
% Inner_num_con=1e+3;
% N=Inner_num_con;
% % Inner_num_con=5000;
% 
% a=[1:N];
% tt=10/(N-1)*a;
% 
%  y1=0.5*exp(-tt)-exp(-2*tt)+0.5*exp(-3*tt)+...
%      1.5*exp(-1.5*tt).*sin(7*tt)+exp(-2.5*tt).*sin(5*tt)+3/20*exp(-tt)+...
%      1/52*exp(-5*tt)-1/65*exp(-2*tt).*(2*sin(2*tt)+11*cos(2*tt))+5*tt;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  n=10;
 Inner_num_con=500;
dim=[2 2 2 n n n n n 2 n n];  % variable T, u1_i,u2_i, in every 



initial_point=cell(length(dim),1);
num.num_obj=cell(length(dim),1);
num.num_con=cell(length(dim),1);
num.num_obj{1}=1;
num.num_obj{2}=ones(2,1);
num.num_obj{3}=1;
num.num_obj{4}=ones(2,1);
num.num_obj{5}=1;
num.num_obj{6}=2*ones(N,1);
num.num_obj{7}=1;
num.num_obj{8}=1;
num.num_obj{9}=1; % degenerate NLP
num.num_obj{10}=1;
num.num_obj{11}=ones(2,1);

% num.num_obj{6}=1;
num.num_con{1}=[2;1];
num.num_con{2}=[4;3]; 
num.num_con{3}=[4;3];   % MPCC
num.num_con{4}=[1;1;2;1;1];
% num.num_con{4}=ones(9*N+11,1);
% num.num_con{4}(4*N+1:6*N)=2;

num.num_con{5}=2*ones(N,1);
% num.num_con{5}=2*(n-1)*ones(N,1);

num.num_con{6}=[1;1;2;1;1];
num.num_con{7}=[2*ones(2*N,1);ones(7*N+11,1)];
num.num_con{8}=[2*ones(2*N,1);1];
num.num_con{9}=ones(3,1);
num.num_con{10}=[N;N;N];
num.num_con{11}=[1;1;Inner_num_con;1;1];

% 4*N-corresponding the bound constraint of u1,u2, 2*N--corresponding 
% the min-costraint,10-corresponding the max-norm, 3*N-the final constraint

% num.num_con{2}(4*N+1:4*N+2*N)=2*ones(2*N,1);  % every max-function conclude a minimum of two functions
% global m;
% m=10;
% num.num_con{6}=[n-2;1];
% initial_point{1}=2*ones(2,1);
% initial_point{2}=[2;2 ];
% initial_point{3}=[.9; .9  ];
% 
% initial_point{4}=zeros(n,1);
% % initial_point{4}=4*ones(dim(4),1);
% initial_point{5}=[zeros(n-1,1);3];
% initial_point{6}=ones(n,1);
% initial_point{7}=4*[1;ones(n-1,1)];
% initial_point{8}=2.5*ones(n,1);
% initial_point{9}=[;-0.01;0.0001];
% initial_point{10}=ones(n,1);
initial_point{11}=zeros(n,1);
% initial_point{3}=[0.5;0.5];
% initial_point{6}=zeros(n,1);
% fid=fopen('ADCH result_ex1.txt','a');
%  fid=fopen('ADCH result_ex2.txt','a');
% fid=fopen('ADCH result_MPCC_ex1.txt','a');
%  fid=fopen('ADCH result_ex4.txt','a');
% fid=fopen('ADCH Result of simple examples on 08.3.1.txt','a');
% fid=fopen('ADCH Result of high_dimension examples on 08.2.29.txt','a');
% fid=fopen('ADCH Result of chang_num uncon on 08.2.29.txt','a');
%  fid=fopen('ADCH result_changeable_dim.txt','a');% 
%  fid=fopen('ADCH result_Robot.txt','a');% 
%  fid=fopen('ADCH result_Robot_original.txt','a');% 
%  fid=fopen('ADCH result_degenerate.txt','a');% 
%  fid=fopen('08-11-16 ex3 for para determine.txt','a');% 
fid=fopen('ADH_TADH.txt','a');% 
% for i=1:3
   i=11;
    example=i;
    fprintf(fid,'\n Example :  %d,  n: %d \n', i, n);
    n=dim(i);
   
    num_obj=num.num_obj{i};
    num_con=num.num_con{i};
    len=length(num_con);
    x_initial=initial_point{i};
    fprintf(fid,'Initial point=[');
    for j=1:n
        fprintf(fid,'%f ',x_initial(j));
    end
    fprintf(fid,'];\n');
    beta_1=1;
    beta_2=1;
   
    [g,g_min]=myfun_con(n,num_con,x_initial,1);
    [rou,p]=para_determin(g_min,x_initial);
    fprintf(fid,'Para: theta=%f, beta_1=%3.2f, beta_2=%3.2f, rou=%3.2f, p=%3.2f\n', theta, beta_1,beta_2,rou,p);
    con_initial_1=myfun_con_grad_aggregate(g,g_min,x_initial,1,num_con,0,1);
    con_initial=zeros(2,1);
    con_initial(1)=-rou;
    con_initial(2)=x_initial'*x_initial-p;
    N_f=0;
    N_g=0;
    N_h=0;
 [fail,x_star,Iter,Inner_Iter,time]=aggregate_deformation_homotopy(x_initial);
 x_star
 Iter
 Inner_Iter
 time
 if fail.value==1
     if fail.iter==1
         fprintf(fid,'Fail for too many iterations!\n');
     end
     if fail.step==1
         fprintf(fid,'Fail for too short step!\n');
     end
 else

     [f,f_min]=myfun_obj(n,num_obj,x_star,1);
     fval=max(f_min)
     fprintf(fid,'Iter=%d Inner_Iter=%d time=%f\n', Iter,Inner_Iter,time);
     fprintf(fid,'N_f=%d  N_g=%d  N_h=%d\n',N_f,N_g,N_h);
     fprintf(fid,'Optimum=[ ');
     for j=1:n
         fprintf(fid,'%f ',x_star(j));
     end
     fprintf(fid,']\n');
     fprintf(fid,'Optimal value=%f\n',fval);
%      [g,g_min]=myfun_con(n,num_obj,x_star,1);
%    
%      fprintf(fid,'Final constraint value=%f\n',g_max);
 end
 if inexact==0
    len_obj=length(num_obj);
    sum_obj=sum(num_obj);
    sum_total=Inner_Iter*( (2*len*Inner_num_con+2*sum_obj+len_obj+len+2)*n^2 +...
        (len*Inner_num_con+sum_obj+1)*n +4/3*(n+2)^3+2*(n+2)^2  );
    sum_num=(Inner_num_con*len+n*Inner_num_con*len)*Inner_Iter;
 else
    sum_total=sum_num*(n^2+n)+Inner_Iter*( 4/3*(n+1)^3+2*(n+1)^2 );
    sum_num=sum_num*(n+1);
     
 end
 
fclose(fid);
return

function     [rou,p]=para_determin(g_min,x);
p=1000+x'*x;
rou=abs(max(g_min))+0.5;

return